﻿using Sample.Models;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace Sample.Controllers
{
    public partial class HomeController : Controller
    {
        //
        // GET: /Home/
        public IEnumerable getValues()
        {
            List<OrderDetails> ordDetails = new List<OrderDetails>();
            var j = 1000;
            var k = 1;
            for (var i = 0; i < 5; i++)
            {
                ordDetails.Add(new OrderDetails()
                {
                    ID = j + 1,
                    CustomerID = "SVSC",
                    EmployeeID = "Beckett",
                    SubDivisionID = 5,
                    OrderDate = DateTime.Now.ToString()
                });
                ordDetails.Add(new OrderDetails()
                {
                    ID = j + 2,
                    CustomerID = "STRQ",
                    EmployeeID = "Smith",
                    SubDivisionID = 8,
                    OrderDate = new DateTime(2015, 12, k, 15, 36, 33).ToString("d MMMM" + ".")
                });
                ordDetails.Add(new OrderDetails()
                {
                    ID = j + 3,
                    CustomerID = "PWQ",
                    EmployeeID = "Fuller",
                    SubDivisionID = 7,
                    OrderDate = new DateTime(2014, 5, k, 22, 23, 36).ToString("MMMM dd, yyyy")
                });
                ordDetails.Add(new OrderDetails()
                {
                    ID = j + 3,
                    CustomerID = "VIN",
                    EmployeeID = "Sam",
                    SubDivisionID = 6,
                    OrderDate = "1/11/15"
                });
                j = j + 3;
                if (k < 31) k++;
                else
                    k = 1;
                if (k == 12) k++;
            }
            return ordDetails.ToList();
        }
        public ActionResult Index()
        {
            ViewBag.data = getValues();
            return View();
        }
        public class OrderDetails
        {
            public OrderDetails()
            {

            }
            public OrderDetails(int id, string Customer, string EmployeeID, int subDivision, string orderDate)
            {
                this.ID = id;
                this.CustomerID = Customer;
                this.EmployeeID = EmployeeID;
                this.SubDivisionID = subDivision;
                this.OrderDate = orderDate;
            }
            public int ID { get; set; }
            public string CustomerID { get; set; }
            public string EmployeeID { get; set; }
            public int SubDivisionID { get; set; }
            public string OrderDate { get; set; }
        }

        public ActionResult ExportToPdf(string GridModel)
        {

            GridProperties gridProperty = ConvertGridObject(GridModel);
            PdfExport exp = new PdfExport();            
            IEnumerable data = getValues();
            PdfDocument pdfdocument = exp.Export(gridProperty, (IEnumerable)data, "Export.pdf", false, false, "flat-lime", true);
            
            pdfdocument.PageSettings.SetMargins(0f);

            RectangleF rect = new RectangleF(0, 0, pdfdocument.PageSettings.Width, 50);
            
            //create a pager template
            PdfPageTemplateElement header = new PdfPageTemplateElement(rect);

            Font  f = new Font("Helvetica", 10, FontStyle.Bold);

            PdfFont font = new PdfTrueTypeFont(f, true);
            
            header.Graphics.DrawString("Demo Report", font, PdfBrushes.Black, new Point(250, 0)); //Add custom text to the Header
            pdfdocument.Template.Top = header; //Append custom template to the document           
            pdfdocument.Save(Server.MapPath("/output/Export.pdf"));
            return RedirectToAction("Index");
        }

        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);

                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

    }


}
